# Articles &amp; Blogs


Here are a few articles and blogs that relate to the Num command, including Unix command line tools for mathematics, statitics, and data analysis.

* <a href="http://www.drbunsen.org/">Dr. Bunsen</a>
* <a href="http://onthelambda.com/">On the lambda</a>
* <a href="http://www.gettinggeneticsdone.com/">Getting Genetics Done</a>
* <a href="http://simplystatistics.org/">Simply Statistics</a>


<article itemprop="citation" itemscope itemtype="http://schema.org/BlogPosting" class="citation">
<header>
<h1><cite itemprop="headline name"><a itemprop="url" href="http://www.drbunsen.org/explorations-in-unix/" rel="external">Explorations in Unix</a></cite></h1>
</header>
<footer>

Few tools are more indispensable to my work than Unix. Manipulating data into different formats, performing transformations, and conducting exploratory data analysis (EDA) is the lingua franca of data science. The coffers of Unix hold many simple tools, which by themselves are powerful, but when chained together facilitate complex data manipulations. &hellip;

<footer>By
<span itemprop="author" itemscope itemtype="http://schema.org/Person"><a itemprop="url" href="https://github.com/drbunsen" rel="external"><span itemprop="name">Seth Brown</span></a></span>,
<span itemprop="isPartOf" itemscope itemtype="http://schema.org/Blog"><a itemprop="url" href="http://www.drbunsen.org/" rel="external"><span itemprop="name">Dr. Bunson</span></a></span>
</footer>
</article>


<article itemprop="citation" itemscope itemtype="http://schema.org/BlogPosting" class="citation">
<header>
<h1><cite itemprop="headline name"><a itemprop="url" href="http://www.onthelambda.com/2013/11/05/qstats-quick-and-dirty-statistics-tool-for-the-unix-pipeline/" rel="external">qstats - quick and dirty statistics tool for Unix</a></cite></h1>
</header>

I wrote a tool, qstats, that computes simple summary statistics from the command-line. It also includes data-binning and simple bar chart functionality. I designed it, in C, specifically to be as fast as possible, and bare-bones enough to work on any POSIX-compliant system without having to deal with outside dependencies. &hellip;

<footer>By
<span itemprop="author" itemscope itemtype="http://schema.org/Person"><a itemprop="url" href="https://github.com/tonyfischetti" rel="external"><span itemprop="name">Tony Fischetti</span></a></span>,
<span itemprop="isPartOf" itemscope itemtype="http://schema.org/Blog"><a itemprop="url" href="http://onthelambda.com" rel="external"><span itemprop="name">On the lambda</span></a></span>
</footer>
</article>


<article itemprop="citation" itemscope itemtype="http://schema.org/BlogPosting" class="citation">
<header>
<h1><cite itemprop="headline name"><a itemprop="url" href="http://www.gettinggeneticsdone.com/2014/09/gnu-datamash.html" rel="external">GNU datamash</a></cite></h1>
</header>

GNU datamash is a command-line utility that offers simple calculations (e.g. count, sum, min, max, mean, stdev, string coalescing) as well as a rich set of statistical functions, to quickly assess information in textual input files or from a UNIX pipe. .... Let’s calculate the mean, 1st quartile, median, 3rd quarile, IQR, sample-standard-deviation, and p-value of Jarque-Bera test for normal distribution, using some data in file.txt. &hellip;

<footer>By
<span itemprop="author" itemscope itemtype="http://schema.org/Person"><a itemprop="url" href="http://stephenturner.us/" rel="external"><span itemprop="name">Stephen Turner</span></a></span>,
<span itemprop="isPartOf" itemscope itemtype="http://schema.org/Blog"><a itemprop="url" href="http://www.gettinggeneticsdone.com/" rel="external"><span itemprop="name">Getting Genetics Done</span></a></span>
</footer>
</article>

<article itemprop="citation" itemscope itemtype="http://schema.org/BlogPosting" class="citation">
<header>
<h1><cite itemprop="headline name"><a itemprop="url" href="http://simplystatistics.org/2015/07/03/the-massive-future-of-statistics-education/" rel="external">The Massive Future of Statistics Education</a></cite></h1>
</header>

Jeff Leek, Brian Caffo, and I launched the Johns Hopkins Data Science Specialization on the Coursera platform. This is a sequence of nine courses that intends to provide a “soup-to-nuts” training in data science for people who are highly motivated and have some basic mathematical and computing background. &hellip;

<footer>By
<span itemprop="author" itemscope itemtype="http://schema.org/Person"><a itemprop="url" href="https://twitter.com/rdpeng" rel="external"><span itemprop="name">Roger Peng</span></a></span>,
<span itemprop="isPartOf" itemscope itemtype="http://schema.org/Blog"><a itemprop="url" href="http://simplystatistics.org/" rel="external"><span itemprop="name">Simply Statistics</span></a></span>
</footer>
</article>



<p><hr><nav>
* <b>[Prev Page: Functions: the complete list of all capabilities](functions.md)</b>
* <b>[Next Page: FAQ: Frequently Asked Questions](faq.md)</b>
</nav>
