# Frequently Asked Questions


## General Questions

### Q. How can I help?

Yes please, and thank you!

If you know programming or UI/UX, we're building Num using GitHub. We welcome help with coding, UI/UX, documentation, examples, community building, and the like.

If you know mathematics and statistics, we will love your opinions about what functionality we should build, and how to get the software to you and your peers.

### Q. How do I pronounce Num?

Num is pronounced like num-ber.

### Q. What is the logo?

The logo is a circle and number sign. The circle is the symbol for a function in a computer software data flow diagram. The number sign is also known as a hash, or octothorpe. If you're a logo creator or graphics designer, we're open to a new logo.

### Q. Is this a one-time project or an ongoing project?

Ongoing. We expect to work on Num for a long time, to improve it and make it available on more systems, and using more implemenations.

### Q. Why do a Kickstarter?

Kickstarter is to get the project launched, and also help more people learn about it. We will use the money to take our existing open source hobby project and turn it into a better, stronger, faster, longer lived project.

### Q. Are there ways to donate?

Yes, lots. You can donate to the lead author directly by using PayPal, Amazon, or Venmo, all to joel@joelparkerhenderson.com, or by using Bitcoin identifier 1366n1MzXZzcqqgxgDjab4TsQ3KjmRF4vK.

### Q. Is the Num project a non-profit?

Not yet, that's a goal. If you're a lawyer or open source advocate who can give pro bono advice about making Num a non-profit, or contributing Num to an existing non-profit, then we'd love to hear from you.


## Technical Questions

### Q. Can Num add feature X?

Generally yes, if the feature is in line with what Num does. We can add the feature to the roadmap for you. If you're able to write the code, or contribute to help fund the feature, that's excellent. Contact us to let us know what you'd like.

### Q. How fast is Num?

Num can process a million numbers per second on a current MacBook Pro. You can read our [benchmarks](benchmarks.md). If you need more speed, try running qstats, datamash, R, python, etc.

### Q. Could any programmer write this?

Yes. Many of the functions can be written in a handful of lines in another tool such as datamash or qstats, or another language such as C or R.

In our day-to-day work, we've written these kinds of functions in these other tools and languages, and now we want to create a software utility that is simpler, cleaner, and better for standards tracking.

We want an easy way to make these functions widely available, even for systems that are locked down or can't have additional programming tools installed. We found that awk provides a good solution for now because it's widely available and very good at handling fields and records.


<p><hr><nav>
* <b>[Prev Page: Articles & Blogs](articles.md)</b>
* <b>[Next Page: Thanks: our coders, advisors, sponsors, donors, and helpers](thanks.md)</b>
</nav>
